#include <stdio.h>
#include <stdlib.h>

#include "static.h"

int global_nums[NumCount];      /* extern (global) aggregate */
static int more_nums[NumCount]; /* scope limited to this file */

int main() {
  fill_array();

  unsigned i;
  for (i = 0; i < NumCount; i++)
    more_nums[i] = i * -1;

  /* confirm initialization worked */
  for (i = 0; i < NumCount; i += 10) 
    printf("%4i\t%4i\n", global_nums[i], more_nums[i]);
    
  return 0;  
}
